<template>
  <div>
    <treePage title="表单按钮列表" @on-result-change="_refresh">
      <template slot="tree">
        <relFormTree ref="treeModal" @on-result-change="_treeData" />
      </template>
      <template slot="cont">
        <el-row>
          <!--查询-->
          <el-col :span="24">
            <Form
              v-show="searchOpen"
              onsubmit="return false"
              :label-width="70"
              inline
              class="search-form"
            >
              <label class="label-sign" />
              <Form-item class="search-item" label="表单名称:">
                <el-input v-model="formObj.name" placeholder="请输入表单名称" clearable @keyup.enter.native="_formSearch" />
              </Form-item>
              <Form-item class="search-item" label="按钮名称:">
                <el-input v-model="formObj.buttonName" placeholder="请输入按钮名称" clearable @keyup.enter.native="_formSearch" />
              </Form-item>
              <Form-item class="search-item" label="备注:">
                <el-input v-model="formObj.buttonRemark" placeholder="请输入备注" clearable @keyup.enter.native="_formSearch" />
              </Form-item>
              <Form-item class="search-btn">
                <el-button type="primary" @click="_formSearch">
                  搜索
                </el-button>
              </Form-item>
            </Form>
          </el-col>
          <!--按钮-->
          <el-col :span="24">
            <btn-list :msg="btn" :open="searchOpen" show-search-btn="true" @on-result-change="_btnClick" />
          </el-col>
          <!--table-->
          <el-col :span="24">
            <element-table
              ref="pageTable"
              :page-columns="pageColumns"
              :table-height="tableHeight"
              :get-page="getPage"
              :icon-msg="iconMsg"
              :opt-col-width="70"
              @on-result-change="_tableResultChange"
            >
              <el-table-column
                v-for="item in pageColumns"
                :key="item.key"
                show-overflow-tooltip
                sortable
                :prop="item.key"
                :label="item.title"
                :width="item.width"
                :min-width="200"
                :fixed="item.fixed?item.fixed:undefined"
              >
                <template slot-scope="scope">
                  <div v-if="item.dateTime">
                    {{ scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd HH:MM:ss'):'' }}
                  </div>
                  <div v-else-if="item.key === 'status'">
                    <span v-if="scope.row[item.key] === 0" class="red-color">禁用</span>
                    <span v-else class="blue-color">正常</span>
                  </div>
                  <div v-else>
                    {{ scope.row[item.key] }}
                  </div>
                </template>
              </el-table-column>
            </element-table>
          </el-col>
        </el-row>
      </template>
    </treePage>
    <!--添加编辑-->
    <formConfigEdit ref="editModal" @on-result-change="_search" />
  </div>
</template>
<script>
import { sysForm, sysFormRelResource } from '../../../api'
import treePage from '../../../components/base/treePage'
import relFormTree from '../resource/tree/relFormTree'
import formConfigEdit from './formConfigEdit'
export default {
  components: {
    treePage,
    relFormTree,
    formConfigEdit
  },
  data() {
    return {
      searchOpen: false,
      btn: [{ type: 'success', id: '', name: '添加' }],
      iconMsg: [
        { type: 'pt-edit', id: '', name: '编辑' },
        { type: 'pt-trash', id: '', name: '删除' }
      ],
      pageColumns: [
        { title: '表单名称', key: 'name' },
        { title: '按钮名称', key: 'buttonName' },
        { title: '状态', key: 'status', width: 120 },
        { title: '备注', key: 'buttonRemark' }
      ],
      formObj: {
        buttonName: '',
        name: '',
        buttonRemark: '',
        buttonIds: []
      },
      getPage: {},
      treeObj: {},
      lastNode: {}
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._search()
  },
  methods: {
    // 刷新
    _refresh() {
      this.formObj = this.$resetFields(this.formObj)
      this.treeObj = {}
      this.lastNode = {}
      this._formSearch()
    },
    _search() {
      this._formSearch()
      this.$refs.treeModal._open()
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await sysForm.pageVO(this.$serializeForm(this.formObj))
      if (result) {
        this.getPage = result
        this.$refs.pageTable._initTable()
      }
    },
    _btnClick(msg, data) {
      switch (msg) {
        case '添加':
          this.$refs.editModal._open(this.treeObj, this.lastNode, '')
          break
        case 'search':
          this.searchOpen = !this.searchOpen
          break
      }
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'page':
          this._page()
          break
        case 'iconClick':
          this._iconClick(data.name, data.rowData)
          break
      }
    },
    _iconClick(res, data) {
      switch (res) {
        case '编辑':
          this.$refs.editModal._open('', '', data)
          break
        case '删除':
          this._deleteById(data.relId)
          break
      }
    },
    _deleteById(relId) {
      this.$confirm('确定解除按钮与表单的关联关系?', '提示', {
        type: 'warning'
      }).then(() => {
        this._delOk(relId)
      })
    },
    _delOk: async function(relId) {
      const result = await sysFormRelResource.deleteById(relId)
      if (result) {
        this.$message.success('删除成功')
        this._page()
      }
    },
    _treeData(data, lastNode, ids) {
      this.formObj.buttonIds = ids.join(',')
      this.treeObj = data
      this.lastNode = lastNode
      this._formSearch()
    }
  }
}
</script>
